import java.io.*;
import java.util.Arrays;
import java.util.StringTokenizer;

/**
 * @author Ilya Peresadin <pva701@gmail.com>
 * @created 27.09.16
 */
public class exhibition_ip implements Closeable {
    public static final int N = 10_000;
    public static final int MAX_VAL = 1<<12;

    FastScanner in;
    PrintWriter out;

    public exhibition_ip() throws IOException {
        in = new FastScanner(new File("exhibition.in"));
        out = new PrintWriter("exhibition.out");
    }

    @Override
    public void close() throws IOException {
        out.close();
    }

    public void run() {
        int n = in.nextInt();
        int k = in.nextInt();
        int[] a = new int[n];
        for (int i = 0; i < n; ++i) {
            a[i] = in.nextInt();
        }
        int[] dp = new int[MAX_VAL];
        Arrays.fill(dp, n + 1);
        dp[MAX_VAL - 1] = 0;
        for (int i = 0; i < n; ++i)
            for (int ms = 0; ms < MAX_VAL; ++ms) {
                dp[ms & a[i]] = Math.min(dp[ms & a[i]], dp[ms] + 1);
            }
        if (dp[0] <= k) {
            out.println("YES");
        } else {
            out.println("NO");
        }
    }

    private void printArray(int[] a, PrintWriter out) {
        int n = a.length;
        for (int i = 0; i < n; ++i)
            if (i + 1 != n) {
                out.print((a[i] + 1) + " ");
            } else {
                out.println(a[i] + 1);
            }
    }

    public static void main(String[] args) throws IOException {
        exhibition_ip instance = new exhibition_ip();
        instance.run();
        instance.close();
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }
}
