import java.io.*;
import java.util.Arrays;
import java.util.StringTokenizer;

/**
 * @author Ilya Peresadin <pva701@gmail.com>
 * @created 27.09.16
 */
public class exhibition_ip2 implements Closeable {
    public static final int N = 10_000;
    public static final int MAX_VAL = 1<<12;

    FastScanner in;
    PrintWriter out;

    public exhibition_ip2() throws IOException {
        in = new FastScanner(new File("exhibition.in"));
        out = new PrintWriter("exhibition.out");
    }

    @Override
    public void close() throws IOException {
        out.close();
    }

    public void run() {
        int n = in.nextInt();
        int k = in.nextInt();
        int[] a = new int[n];
        for (int i = 0; i < n; ++i) {
            a[i] = in.nextInt();
        }
        int[][] dp = new int[N + 1][MAX_VAL];
        for (int i = 0; i < MAX_VAL; ++i) {
            dp[0][MAX_VAL - 1] = k + 1;
        }
        for (int i = 0; i < n; ++i)
            for (int ms = 0; ms < MAX_VAL; ++ms) {
                dp[i + 1][ms] = Math.max(dp[i + 1][ms], dp[i][ms]);
                dp[i + 1][ms & a[i]] = Math.max(dp[i + 1][ms & a[i]], dp[i][ms] - 1);
            }
        if (dp[n][0] >= 1) {
            out.println("YES");
        } else {
            out.println("NO");
        }
    }

    public static void main(String[] args) throws IOException {
        exhibition_ip2 instance = new exhibition_ip2();
        instance.run();
        instance.close();
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }
}
