import java.io.*;
import java.util.StringTokenizer;

/**
 * @author Ilya Peresadin <pva701@gmail.com>
 * @created 27.09.16
 */
public class pots_ip implements Closeable {

    public static final int N = 100000;
    public static final int MAX_VAL = 1_000_000_000;

    class Pair implements Comparable<Pair> {
        int val, index;

        Pair(int val, int index) {
            this.val = val;
            this.index = index;
        }

        @Override
        public int compareTo(Pair o) {
            return val - o.val;
        }
    }

    FastScanner in;
    PrintWriter out;

    public pots_ip() throws IOException {
        in = new FastScanner(new File("pots.in"));
        out = new PrintWriter("pots.out");
    }

    @Override
    public void close() throws IOException {
        out.close();
    }

    public void run() {
        int n = in.nextInt();
        int[] a = new int[n];
        for (int i = 0; i < n; ++i) {
            a[i] = in.nextInt();
        }

        int i1 = -1, i2 = -2, c = 0;
        for (int i = 0; i < n; ++i) {
            if (a[i] % 2 != (i + 1) % 2) {
                ++c;
                if (i1 == -1) {
                    i1 = i;
                } else {
                    i2 = i;
                }
            }
        }

        if (c == 1 || c > 2 || n == 1 || c == 0 && n == 2 || i1 % 2 == i2 % 2) {
            out.println("-1 -1");
        } else {
            if (c == 0) {
                i1 = 0;
                i2 = 2;
            }
            out.println((i1 + 1) + " " + (i2 + 1));
        }
    }

    public static void main(String[] args) throws IOException {
        pots_ip instance = new pots_ip();
        instance.run();
        instance.close();
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }
}
