#include <cstdio>
#include <iostream>
#include <cassert>
#include <vector>
#include <map>
#include <algorithm>
#include <sstream>
#include "testlib.h"

using namespace std;

const int MAXX = 200;
int cur_test = -1;

string itoa(int x) 
{
    stringstream ss;
    string s;
    ss << x;
    ss >> s;
    return s;
}

int atoi(string s) 
{
    stringstream ss;
    int x;
    ss << s;
    ss >> x;
    return x;
}

void write_test(int h, int l, int a, int b) 
{
    startTest(cur_test++);
    cerr << cur_test << endl;
    if (rnd.next(2)) swap(a, b);
    printf("%d %d %d %d\n", h, l, a, b);
}

void gen_rand(int maxn)
{
    int h = rnd.next(maxn) + 1;
    int l = rnd.next(maxn) + 1;
    int a = rnd.next(maxn) + 1;
    int b = rnd.next(maxn) + 1;
    write_test(h, l, a, b);    
}

void gen_rand1(int maxn)
{
    int h = rnd.next(maxn / 2) + 1;
    int l = rnd.next(maxn) + 1;
    int a = 2 * h;
    int b = rnd.next(l) + 1;
    write_test(h, l, a, b);    
}

void gen_rand2(int maxn)
{
    int h = rnd.next(maxn / 2) + 1;
    int l = rnd.next(maxn) + 1;
    int a = 2 * h + 1;
    int b = rnd.next(l) + 1;
    write_test(h, l, a, b);    
}


int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    cur_test = atoi(argv[1]);

    for (int i = 50; i <= MAXX; i += 50)     
    {
        gen_rand(i);
        gen_rand(i);
        gen_rand1(i);
        gen_rand2(i);
    }
    write_test(MAXX / 2, MAXX, MAXX, MAXX);
    write_test(MAXX, MAXX - 1, MAXX, MAXX);
    write_test(MAXX / 2 - 1, MAXX, MAXX, MAXX);
    write_test((MAXX - 1) / 2, MAXX, MAXX - 1, MAXX);
    write_test(MAXX, MAXX, MAXX, MAXX);
    
    return 0;
}