import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;

import java.util.Arrays;

public class Check implements Checker {
    public static final int MAX_VAL = 1<<12;

    int[] readArray(int n, InStream is) {
        int[] ar = new int[n];
        for (int i = 0; i < n; ++i) {
            ar[i] = is.nextInt();
        }
        return ar;
    }

    String check(int[] b, int[] cnt) {
        int res = b[0];
        if (cnt[b[0]] == 0) {
            return "Answer is invalid";
        }
        cnt[b[0]]--;
        for (int i = 1; i < b.length; ++i) {
            res &= b[i];
            if (cnt[b[i]] == 0) {
                return "Answer is invalid";
            }
            cnt[b[i]]--;
        }
        if (res != 0) {
            return "Bitwise and isn't equal zero";
        }
        return null;
    }

    private int[] calcCnt(int[] a) {
        int[] cnt = new int[1<<12];
        for (Integer x : a) {
            cnt[x]++;
        }
        return cnt;
    }

    @Override
    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        String jr = ans.nextToken().toLowerCase();
        String prt = ouf.nextToken().toLowerCase();

        if (!jr.equals("yes") && !jr.equals("no")) {
            return new Outcome(Outcome.Type.FAIL, "Expected YES or NO from Jury, but received " + jr);
        }

        if (!prt.equals("yes") && !prt.equals("no")) {
            return new Outcome(Outcome.Type.PE, "Expected YES or NO from part, but received " + prt);
        }

        if (jr.equals("yes") && prt.equals("no")) {
            return new Outcome(Outcome.Type.WA, "Jury have answer, but part doesn't have!");
        } else if (jr.equals("no") && prt.equals("yes")) {
            return new Outcome(Outcome.Type.WA, "Jury don't have answer, but part has answer!");
        } else if (jr.equals("no")) {
            return new Outcome(Outcome.Type.OK, "No solution!");
        }

        ans.nextLine();
        ans.close();
        ouf.seekEoF();
        ouf.close();

        return new Outcome(Outcome.Type.OK, "OK. Answer is found");
    }
}
