#include "bits/stdc++.h"
#include "testlib.h"
#define puba push_back
#define mapa make_pair
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const double PI = atan2(0, -1);
const int MAXN = 100000, MAXK = 100000, MAXC = 1000000;
const ll MAXV = 1e18;

struct point {
    int x, y;
    point() {
        x = y = 0;
    }
    point(int _x, int _y) {
        x = _x;
        y = _y;
    }
    ll operator*(point p) {
        return (ll) x * p.y - (ll) y * p.x;
    }
    ll operator/(point p) {
        return (ll) x * p.x + (ll) y * p.y;
    }
    point operator-(point p) {
        return point(x - p.x, y - p.y);
    }
    point operator+(point p) {
        return point(x + p.x, y + p.y);
    }
    point operator+=(point p) {
        x += p.x;
        y += p.y;
        return *this;
    }
    double len() {
        return sqrt(x * x + y * y);
    }
    void print() {
        cerr << x << " " << y << endl;
    }
};

bool cmp(point p1, point p2) {
    return p1 * p2 > 0;
}

vector<point> gen_polygon(int sz) {
    int maxc = MAXC * 2 / sz;
    vector<point> up, down;
    set<pii> have;
    ll sumx = 0, sumy = 0;
    for (int i = 0; i < sz - 1; ++i) {
        int x = 0, y = 0;
        while (true) {
            //cerr << szof(have) << endl;
            x = rnd.next(-maxc, maxc);
            y = rnd.next(-maxc, maxc);
            if (x == 0 && y == 0) {
                continue;
            }
            int tmp = __gcd(abs(x), abs(y));
            int nx = x / tmp;
            int ny = y / tmp;
            if (nx < 0) {
                nx *= -1;
                ny *= -1;
            } else if (nx == 0 && ny < 0) {
                ny *= -1;
            }
            if (!have.insert({nx, ny}).ss) {
                continue;
            }
            break;
        }
        if (y > 0 || (y == 0 && x > 0)) {
            up.puba(point(x, y));
        } else {
            down.puba(point(x, y));
        }
        sumx += x;
        sumy += y;
    }

    sumx *= -1;
    sumy *= -1;

    if (sumx != 0 || sumy != 0) {
        int tmp = __gcd(abs(sumx), abs(sumy));
        int nx = sumx / tmp;
        int ny = sumy / tmp;
        if (nx < 0) {
            nx *= -1;
            ny *= -1;
        } else if (nx == 0 && ny < 0) {
            ny *= -1;
        }
        
        if (have.count({nx, ny})) {
            if (sumy > 0 || (sumy == 0 && sumx > 0)) {
                for (int i = 0; i < szof(up); ++i) {
                    auto& el = up[i];
                    tmp = __gcd(abs(el.x), abs(el.y));
                    int nnx = el.x / tmp;
                    int nny = el.y / tmp;
                    if (nnx < 0) {
                        nnx *= -1;
                        nny *= -1;
                    } else if (nnx == 0 && nny < 0) {
                        nny *= -1;
                    }
                    if (nx == nnx && ny == nny) {
                        el.x += sumx;
                        el.y += sumy;
                        if (el.x == 0 && el.y == 0) {
                            up.erase(up.begin() + i);
                        }
                        break;
                    }
                } 
            } else {
                for (int i = 0; i < szof(down); ++i) {
                    auto& el = down[i];
                    tmp = __gcd(abs(el.x), abs(el.y));
                    int nnx = el.x / tmp;
                    int nny = el.y / tmp;
                    if (nnx < 0) {
                        nnx *= -1;
                        nny *= -1;
                    } else if (nnx == 0 && nny < 0) {
                        nny *= -1;
                    }
                    if (nx == nnx && ny == nny) {
                        el.x += sumx;
                        el.y += sumy;
                        if (el.x == 0 && el.y == 0) {
                            down.erase(down.begin() + i);
                        }
                        break;
                    }
                }
            }
        } else {
            if (sumy > 0 || (sumy == 0 && sumx > 0)) {
                up.puba(point(sumx, sumy));
            } else {
                down.puba(point(sumx, sumy));
            }
        }
    }

    sort(bend(up), cmp);
    sort(bend(down), cmp);
    vector<point> order = down;
    for (auto p: up) {
        order.puba(p);
    }

    rotate(order.begin(), order.begin() + rnd.next(0, sz - 1), order.end());
    order.pop_back();

    vector<point> ret;
    ret.puba(point(0, 0));

    int minx = 0, maxx = 0, miny = 0, maxy = 0;

    for (auto p: order) {
        ret.puba(ret.back() + p);
        minx = min(minx, ret.back().x);
        maxx = max(maxx, ret.back().x);
        miny = min(miny, ret.back().y);
        maxy = max(maxy, ret.back().y);
    }
    //cerr << minx << " " << maxx << " " << miny << " " << maxy << endl;
    point shift = point(rnd.next(-MAXC - minx, MAXC - maxx), rnd.next(-MAXC - miny, MAXC - maxy));
    for (auto& p: ret) {
        p += shift;
    }
    return ret;
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    assert(argc >= 3);
    int n = atoi(argv[1]);
    int k = atoi(argv[2]);

    cout << n << " " << rnd.next(1ll, MAXV) << "\n";

    for (int i = 0; i < n; ++i) {
        vector<point> pol = gen_polygon(k);
        cout << szof(pol) << "\n";

        for (auto p: pol) {
            cout << p.x << " " << p.y << "\n";
        }
    }
    
    return 0;
}