import random
random.seed("basic03/kdivision")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test([[248, 16, 45, 2], [248, 16, 46, 2], [4444, 1, 5, 2]])

    def generate_min_tests(self):
        self.print_test([[2, 0, 1, 1], [1, 1, 100, 1], [9, 0, 0, 1], [239, 0, 0, 1], [999999, 0, 0, 1], [11, 1, 1, 1], [11, 0, 1, 2], [111, 1, 1, 1], [111, 1, 1, 2], [111, 0, 0, 3]])
        
    def generate_hand_tests(self):
        pass

    def generate_random_test(self, maxn, digits=[0, 1, 2, 3, 4, 5, 6, 7, 8, 9]):
        tests = []
        while len(tests) < 100:
            x = 0
            length = maxn
            for i in range(length):
                ind = random.randint(0, len(digits) - 1)
                while i == 0 and digits[ind] == 0:
                    ind = random.randint(0, len(digits) - 1)
                x = x * 10 + digits[ind]
            for k in range(1, length + 1):
                for maxv in [10, 10**3, 10**5, 10**9, 10**18]:
                    if len(tests) < 100:
                        l = random.randint(0, min(maxv, 100))
                        r = random.randint(l, maxv)
                        tests.append([x, l, r, k])
        self.print_test(tests)

    def generate_max_tests(self, maxn):
        tests = []
        for k in range(1, 19):
            tests.append([maxn, 0, 10**(18 - k), k])
            tests.append([maxn - 1, 0, 10**(18 - k), k])
            tests.append([int('1' * 18), 0, 10**18, k])
            tests.append([int('2' * 18), 0, 10**18, k])
            tests.append([int('10' * 9), 0, 10**18, k])
        self.print_test(tests)

    def print_test(self, tests):
        self.test_number += 1
        print('Generating test #%d' % self.test_number)

        test_name = "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, "w")
        print(len(tests), file=test_file)
        for test in tests:
            print(test[0], test[1], test[2], test[3], file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()
        self.generate_min_tests()
        self.generate_hand_tests()
        
        ns = [2, 3, 4, 5, 10, 12, 15, 18]
        sets = [[1], [2], [1, 2], [1, 2, 3], [2, 3, 5], [5, 7, 9], [1, 2, 3, 5, 7, 9]]
        for n in ns:
            self.generate_random_test(n)
            for s in sets:
                self.generate_random_test(n, s)
        self.generate_max_tests(10**18)

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
