#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

string ending(long long x)
{
	x %= 100;
	if (x / 10 == 1)
		return "th";
	if (x % 10 == 1)
		return "st";
	if (x % 10 == 2)
		return "nd";
	if (x % 10 == 3)
		return "rd";
	return "th";
}

string ltoa(long long n)
{
	stringstream ss;
	ss << n;
	string result;
	ss >> result;
	return result;
}

const int dd = 1e5 + 7;

vector<int> A, B, E;

int main(int argc, char * argv[])
{
	setName("compare ordered sequences of signed int%d numbers", 8 * sizeof(long long));

	registerTestlibCmd(argc, argv);

	int N = inf.readInt();
    int M = inf.readInt();
	long long R = 0;
	A.resize(M);
	B.resize(M);
	E.resize(M);
    for (int i = 0; i < M; i++) {
        A[i] = inf.readInt();
        B[i] = inf.readInt();
        E[i] = inf.readInt();
		R += E[i];
    }

	int n = 0;

	string firstElems;

	vector<int> T;

	while (!ans.seekEof() && !ouf.seekEof())
	{
		n++;
		long long j = ans.readLong();
		long long p = ouf.readLong();
		T.push_back(p);
		if(p != 0 && p != 1){
			quitf(_pe, "%d%s number - expected: 1 or 0, found: '%s'", n, ending(n).c_str(), ltoa(p).c_str());
		}
	}


	int extraInAnsCount = 0;

	while (!ans.seekEof())
	{
		ans.readLong();
		extraInAnsCount++;
	}

	int extraInOufCount = 0;

	while (!ouf.seekEof())
	{
		ouf.readLong();
		extraInOufCount++;
	}

	if (extraInAnsCount > 0)
		quitf(_wa, "Answer contains longer sequence [length = %d], but output contains %d elements", n + extraInAnsCount, n);

	if (extraInOufCount > 0)
		quitf(_wa, "Output contains longer sequence [length = %d], but answer contains %d elements", n + extraInOufCount, n);
	
    //quitf(_pe, "%d %d", (int)G, (int)R);
    
	long long G = 0;

	for(int i = 0; i < M; i++){
		if(T[A[i] - 1] == T[B[i] - 1]){
			G += E[i];
		}
	}
	
	if(G * 2 > R){
		quitf(_wa, "Sum of edges is greater than R/2: G = %d R = %d", (int)G, (int)R);
	}

	if (n <= 5)
	{
		quitf(_ok, "%d number(s): \"%s\"", n, firstElems.c_str());
	}
	else
		quitf(_ok, "%d numbers", n);
}