import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;

import java.util.Arrays;

public class Check implements Checker {
    public static final int MAX_VAL = 1_000_000_000;

    public boolean isPerm(int[] a) {
        int n = a.length;
        boolean[] use = new boolean[n];
        for (int x : a) {
            if (x < 0 || x >= n || use[x]) {
                return false;
            }
            use[x] = true;
        }
        return true;
    }

    int[] readArray(int n, InStream is) {
        int[] ar = new int[n];
        for (int i = 0; i < n; ++i) {
            ar[i] = is.nextInt();
        }
        return ar;
    }

    public String check(int[] a, int x, int y) {
        if (x == -1 && y == -1) {
            return null;
        }
        int n = a.length;
        if (x == y) {
            return "Indexes are equal";
        }
        
        if (x <= 0 || y <= 0) {
            return "Negative index";
        }

        if (x > n) {
            return "x > n";
        } else if (x < 0) {
            return "x < 0";
        }

        if (y > n) {
            return "y > n";
        } else if (y < 0) {
            return "y < 0";
        }

        int t = a[x - 1];
        a[x - 1] = a[y - 1];
        a[y - 1] = t;
        for (int i = 0; i < n; ++i)
            if ((i + 1) % 2 != a[i] % 2) {
                return String.format("a[%d] mod 2 != %d mod 2. a[%d]=%d", i + 1, i + 1, i + 1, a[i]);
            }
        return "";
    }

    @Override
    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        int iPart = ouf.nextInt(), jPart = ouf.nextInt();
        int iJury = ans.nextInt(), jJury = ans.nextInt();
        int n = inf.nextInt();
        int[] a = readArray(n, inf);
        int[] b = Arrays.copyOf(a, n);
        String jRes = check(a, iJury, jJury);
        if (jRes != null && !jRes.isEmpty()) {
            return new Outcome(Outcome.Type.FAIL, jRes);
        }
        String pRes = check(b, iPart, jPart);
        if (pRes != null && !pRes.isEmpty()) {
            return new Outcome(Outcome.Type.WA, pRes);
        }

        ans.nextLine();
        ans.close();
        ouf.seekEoF();
        ouf.close();
        if (pRes == null && jRes == null) {
            return new Outcome(Outcome.Type.OK, "No solution");
        } else if (pRes != null && jRes != null) {
            return new Outcome(Outcome.Type.OK, "OK. Party answer = " + iPart + " " + jPart);
        } else if (jRes == null) {
            return new Outcome(Outcome.Type.FAIL, "Jury don't have solution, but participant has");
        } else {
            return new Outcome(Outcome.Type.WA, "Jury have solution, but participant doesn't have");
        }
    }
}
