import random
random.seed("basic03/travelling")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test(4, 7)
        self.print_test(10, 100)

    def generate_min_tests(self):
        self.print_test(1, 1)
        self.print_test(1, 10)
        self.print_test(7, 7)

    def generate_hand_tests(self):
        pass

    def generate_good_number(self, maxn):
        if maxn < 10:
            digit = random.randint(1, maxn)
        else:
            digit = random.randint(1, 9)
        k = 1
        x = digit
        while x * 10 + digit <= maxn:
            k += 1
            x = x * 10 + digit
        return int(str(digit) * random.randint(1, k))

    def generate_clever_random_test(self, maxn):
        l = self.generate_good_number(maxn)
        r = self.generate_good_number(maxn)
        l += random.randint(-1, 1)
        r += random.randint(-1, 1)
        self.print_test(min(l, r), max(l, r))

    def generate_random_test(self, maxn):
        l = random.randint(1, maxn)
        r = random.randint(l, maxn)
        self.print_test(l, r)

    def generate_max_tests(self, maxn):
        self.print_test(1, maxn)
        self.print_test(maxn, maxn)

    def print_test(self, l, r):
        self.test_number += 1
        print('Generating test #%d' % self.test_number)

        test_name = "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, "w")
        print(l, r, file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()
        self.generate_min_tests()
        self.generate_hand_tests()
        
        ns = [5, 10, 100, 1000, 10**5, 10**9, 10**12, 10**15, 10**18]
        for n in ns:
            self.generate_random_test(n)
            for i in range(6):
                self.generate_clever_random_test(n)
        self.generate_max_tests(10**18)

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
