#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int MAX = 5e8;
const int N = 100179;

struct Treap
{
	static Treap * null;
	int x, y, val, sum;
	Treap * l, * r;
	Treap(const char *) : x(0), y(0), val(0), sum(0), l(this), r(this) {}
	Treap(int nx, int nval = 0) : x(nx), y(rand()), val(nval), sum(nval), l(null), r(null) {}

	void update()
	{
		sum = l->sum + val + r->sum;
	}
};
Treap * Treap::null = new Treap("...");

Treap * merge(Treap * l, Treap * r)
{
	if (l == Treap::null) return r;
	if (r == Treap::null) return l;
	if (l->y > r->y)
	{
		l->r = merge(l->r, r);
		l->update();
		return l;
	} else {
		r->l = merge(l, r->l);
		r->update();
		return r;
	}
}

void split(Treap * t, int x, Treap *& l, Treap *& r)
{
	if (t == Treap::null)
	{
		l = r = t;
		return;
	}
	if (t->x < x)
	{
		l = t;
		split(t->r, x, t->r, r);
	} else {
		r = t;
		split(t->l, x, l, t->l);
	}
	t->update();
}

bool tadd(Treap * t, int x, int v)
{
	if (t == Treap::null)
		return false;
	if (t->x == x)
	{
		t->val += v;
		t->sum += v;
		return true;
	} else if (x < t->x)
	{
		if (tadd(t->l, x, v))
		{
			t->sum += v;
			return true;
		}
		return false;
	} else {
		if (tadd(t->r, x, v))
		{
			t->sum += v;
			return true;
		}
		return false;
	}
}

class MSet
{
	Treap * t;
public:
	MSet() : t(Treap::null) {}
	void add(int p, int v)
	{
		if (!tadd(t, p, v))
		{
			Treap * t1, * t2;
			split(t, p, t1, t2);
			t = merge(merge(t1, new Treap(p, v)), t2);
		}
	}
	int get(int p)
	{
		Treap * t1, * t2;
		split(t, p, t1, t2);
		int w = t1->sum;
		t = merge(t1, t2);
		return w;
	}
	int get(int l, int r)
	{
		Treap * t1, * t2, * t3;
		split(t, l, t1, t2);
		split(t2, r + 1, t2, t3);
		int w = t2->sum;
		t = merge(t1, merge(t2, t3));
		return w;
	}
};

map < int , MSet > fs, fl, fr;
MSet fw;

int n, s, l[N], r[N];
ll ans = 0;
bool e[N];

int cnt(int l, int r)
{
	if (r - l > s)
		return 0;
	int a = 0;
	int s1 = s - (r - l);
	a += fs[s1].get(r + 1, MAX);
	a += fs[s1].get(-MAX, l - s1 - 1);
	a += fs[s].get(l - s1, l);
	a += fr[r + s1].get(l + 1, r);
	a += fl[l - s1].get(l, r);
	if (r - l == s)
		a += fw.get(l + 2);
	return a;
}

int main()
{
#ifndef LOCAL
	freopen("twosegments.in", "r", stdin);
	freopen("twosegments.out", "w", stdout);
#endif

	scanf("%d%d", &s, &n);
	for (int i = 0; i < n; ++i)
	{
		int t;
		scanf("%d", &t);
		if (t == 1)
		{
			scanf("%d%d", l+i, r+i);
			ans += cnt(l[i], r[i]);
			fs[r[i] - l[i]].add(l[i], 1);
			fl[l[i]].add(r[i], 1);
			fr[r[i]].add(l[i], 1);
			if (r[i] - l[i] <= s - 2)
			{
				fw.add(r[i] - (s - 2), 1);
				fw.add(l[i] + 1, -1);
			}
			e[i] = true;
		} else {
			int k;
			scanf("%d", &k);
			--k;
			e[k] = false;
			fs[r[k] - l[k]].add(l[k], -1);
			fl[l[k]].add(r[k], -1);
			fr[r[k]].add(l[k], -1);
			if (r[k] - l[k] <= s - 2)
			{
				fw.add(r[k] - (s - 2), -1);
				fw.add(l[k] + 1, 1);
			}
			ans -= cnt(l[k], r[k]);
		}
		printf("%lld\n", ans);
	}


	return 0;
}
